<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreatePackingMaterialChecklistsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('qc_packing_material_checklists', function (Blueprint $table) {
            $table->id('packing_material_data_id');
            $table->integer('packing_material_id');
            $table->string('weight_strapping_rolls')->nullable();
            $table->string('thickness_strapping_rolls')->nullable();
            $table->string('appearance_strapping_rolls')->nullable();
            $table->string('width_strapping_rolls')->nullable();
            $table->string('remarks_strapping_rolls')->nullable();
            $table->string('hardness_clips')->nullable();
            $table->string('remarks_clips')->nullable();
            $table->string('old_weight_film_roll')->nullable();
            $table->string('old_appearance_film_roll')->nullable();
            $table->boolean('old_is_sticky_film_roll')->default(false);
            $table->string('new_weight_film_roll')->nullable();
            $table->string('new_appearance_film_roll')->nullable();
            $table->boolean('new_is_sticky_film_roll')->default(false);
            $table->string('remarks_film_roll')->nullable();
            $table->string('old_internal_length_carton_packings')->nullable();
            $table->string('old_internal_width_carton_packings')->nullable();
            $table->string('old_internal_height_carton_packings')->nullable();
            $table->string('old_external_length_carton_packings')->nullable();
            $table->string('old_external_width_carton_packings')->nullable();
            $table->string('old_external_height_carton_packings')->nullable();
            $table->string('new_internal_length_carton_packings')->nullable();
            $table->string('new_internal_width_carton_packings')->nullable();
            $table->string('new_internal_height_carton_packings')->nullable();
            $table->string('new_external_length_carton_packings')->nullable();
            $table->string('new_external_width_carton_packings')->nullable();
            $table->string('new_external_height_carton_packings')->nullable();
            $table->string('weight_carton_packings')->nullable();
            $table->string('no_of_ply_carton_packings')->nullable();
            $table->string('appearance_carton_packings')->nullable();
            $table->string('color_carton_packings')->nullable();
            $table->string('remarks_carton_packings')->nullable();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('qc_packing_material_checklists');
    }
}
