<?php

namespace Modules\Qc\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;


class DailyLabReportNightAttachment extends Model
{
    use HasFactory, LogsActivity;

    protected $table = 'qc_daily_lab_report_night_attachments';
    protected $primaryKey = 'dlr_night_attachment_id';
    protected $fillable = [];

    protected static $logAttributes = [
        'dlr_night_attachment_id',
        'dlr_night_id',
        'path',
        'token'
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "qc_daily_lab_report_night_attachments";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }
}