<?php

namespace Modules\Qc\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;


class DamageCheckingRecordsData extends Model
{
    use HasFactory, LogsActivity;

    protected $table = 'qc_damage_checking_records_data';
    protected $primaryKey = 'dcr_data_id';
    protected $fillable = [];

    protected static $logAttributes = [
        "dcr_data_id",
        "dcr_id",
        "shift_id",
        "hour",
        "seal_damage",
        "block_damage",
        "slab_damage",
        "print_damage",
        "packing_damage",
        "other_damage",
        "remarks",
        "qc_seal_damage",
        "qc_block_damage",
        "qc_slab_damage",
        "qc_print_damage",
        "qc_packing_damage",
        "qc_other_damage",
        "qc_remarks"
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "qc_damage_checking_records_data";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }

}