<?php

namespace Modules\Qc\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;


class ElectricalConductivityCheckListData extends Model
{
    use HasFactory, LogsActivity;

    protected $table = 'qc_electrical_conductivity_check_list_data';
    protected $primaryKey = 'electrical_conductivity_data_id';
    protected $fillable = [];

    protected static $logAttributes = [
        'electrical_conductivity_data_id',
        'electrical_conductivity_id',
        'hour',
        'ec_unit',
        'color',
        'remarks'
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "qc_electrical_conductivity_check_list_data";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }
}