<?php

namespace Modules\Qc\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;


class PallatizingDetailsHeader extends Model
{
    use HasFactory, LogsActivity;

    protected $table = 'qc_pallatizing_details_headers';
    protected $primaryKey = 'pallatizing_id';
    protected $fillable = [];

    protected static $logAttributes = [
        "pallatizing_id",
        "user_id",
        "reference_no",
        "date",
        "customer_order_plan_data_id",
        "factory"
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "qc_pallatizing_details_headers";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }
}