<?php

namespace Modules\Qc\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;

class ProductionWeightReport extends Model
{
    use HasFactory, LogsActivity;

    protected $table = 'qc_production_weight_reports';
    protected $primaryKey = 'pwr_data_id';
    protected $fillable = [];

    protected static $logAttributes = [
        'pwr_data_id',
        'pwr_id',
        'hour',
        'sample_no',
        'ob1',
        'ob2',
        'ob3',
        'ob4',
        'ob5'
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "qc_production_weight_reports";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }


}