<?php

namespace Modules\Qc\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;


class SupervisorCheckListData extends Model
{
    use HasFactory, LogsActivity;

    protected $table = 'qc_supervisor_check_list_data';
    protected $primaryKey = 'scl_data_id';
    protected $fillable = [];
    protected static $logAttributes = [
        'scl_data_id',
        'scl_id',
        'net_size',
        'siever_magnet',
        'scales_mixing_area',
        'scales_finished_good_area',
        'volume_bucket_accuracy',
        'no_of_qcs',
        'qc_allocated_places'
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "qc_supervisor_check_list_data";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }

}