var action = "save";
var scl_id = "";
var tableData = undefined;
var tableDataMaterial = undefined;
var machineryData = getMachineryData();
var materialData = getMaterialData();
$(document).ready(function () {
    tableData = $("#tblData").transactionTable({
        thead: ["Machine Type", "Remarks"],
        column_def: { 0: 100 },
        auto_focus: 0,
        row_type: [
            { type: "select", value: [], align: "left", width: "200px" },
            { type: "text", value: "", align: "left", width: "100%" },
            { type: "remove", value: "X", align: "center" },
        ],
    });

    tableDataMaterial = $("#tblDataMaterial").transactionTable({
        thead: ["Material Type", "Remarks"],
        column_def: { 0: 100 },
        auto_focus: 0,
        row_type: [
            { type: "select", value: [], align: "left", width: "200px" },
            { type: "text", value: "", align: "left", width: "100%" },
            { type: "remove", value: "X", align: "center" },
        ],
    });

    getOrderNo();
    getProductPrimaryId();
    getShiftData();
    getFactoryData();

    if (window.location.search.length > 0) {
        var sPageURL = window.location.search.substring(1);
        var param = sPageURL.split("?");
        scl_id = param[0].split("=")[1].split("&")[0];
        action = param[0].split("=")[2].split("&")[0];
        getSclData(scl_id);
        if (action == "edit") {
            $("#btnSave").text("Update");
        } else if (action == "view") {
            $("#btnSave").hide();
            $("#addRowBtn").hide();
            $("#addRowBtnMaterial").hide();
            $("#product_primary_id").prop("disabled", true);
            $("#customer_order_plan_data_id").prop("disabled", true);
            $("#date").prop("disabled", true);
        }
    } else {
        tableData.add_empty_row();
        tableDataMaterial.add_empty_row();
    }

    $("#btnSave").on("click", function () {
        if ($(this).text() == "Save") {
            saveSclRecord();
        } else {
            updateSclRecords(scl_id);
        }
    });

    addRowDataMaterial();
    addRowDataMachine();
});

function addEmptyRow() {
    tableData.add_empty_row();
    addRowDataMaterial();
    addRowDataMachine();
}

function addEmptyRowMaterial() {
    tableDataMaterial.add_empty_row();
    addRowDataMaterial();
    addRowDataMachine();
}

function addRowDataMachine(data) {


    var selected_row = tableData.getSelectedRow();
    var cells = selected_row.getElementsByTagName("td");



    $("#" + cells[0].childNodes[0].id).append(
        '<option value="">--Select--</option>'
    );

    for (var i = 0; i < machineryData.length; i++) {
        if (data == machineryData[i].machinery_id) {
            $("#" + cells[0].childNodes[0].id).append(
                '<option value="' +
                machineryData[i].machinery_id +
                '" selected>' +
                machineryData[i].machinery_name +
                "</option>"
            );
        } else {
            $("#" + cells[0].childNodes[0].id).append(
                '<option value="' +
                machineryData[i].machinery_id +
                '">' +
                machineryData[i].machinery_name +
                "</option>"
            );
        }
    }

}

function addRowDataMaterial(data) {

    var selected_row_material = tableDataMaterial.getSelectedRow();
    var cellsMaterial = selected_row_material.getElementsByTagName("td");

    $("#" + cellsMaterial[0].childNodes[0].id).append(
        '<option value="">--Select--</option>'
    );


    for (var i = 0; i < materialData.length; i++) {
        if (data == materialData[i].mt_id) {
            $("#" + cellsMaterial[0].childNodes[0].id).append(
                '<option value="' +
                materialData[i].mt_id +
                '" selected>' +
                materialData[i].material_name +
                "</option>"
            );
        } else {
            $("#" + cellsMaterial[0].childNodes[0].id).append(
                '<option value="' +
                materialData[i].mt_id +
                '">' +
                materialData[i].material_name +
                "</option>"
            );
        }
    }
}

function getMachineryData() {
    var data = [];
    $.ajax({
        type: "GET",
        url: "/qc/SupervisorCheckListDataController/getMachineryData",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () { },
        success: function (response) {
            for (var i = 0; i < response.data.result.length; i++) {
                data.push({
                    machinery_id: response.data.result[i].machinery_id,
                    machinery_name: response.data.result[i].machinery_name,
                });
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () { },
    });

    return data;
}

function getMaterialData() {
    var data = [];
    $.ajax({
        type: "GET",
        url: "/qc/SupervisorCheckListDataController/getMaterialData",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () { },
        success: function (response) {
            console.log(response.data.result);
            for (var i = 0; i < response.data.result.length; i++) {
                data.push({
                    mt_id: response.data.result[i].product_primary_id,
                    material_name: response.data.result[i].product_name,
                });
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () { },
    });

    return data;
}

function getShiftData() {
    $.ajax({
        type: "GET",
        url: "/qc/DamageCheckingRecordsDataController/getShiftData",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () { },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            for (var i = 0; i < res.length; i++) {
                $("#shift").append(
                    '<option value="' +
                    res[i].shift_id +
                    '">' +
                    res[i].shift_name +
                    "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () { },
    });
}

function getFactoryData() {
    $.ajax({
        type: "GET",
        url: "/qc/SupervisorCheckListDataController/getFactoryData",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () { },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            for (var i = 0; i < res.length; i++) {
                $("#factory").append(
                    '<option value="' +
                    res[i].site_id +
                    '">' +
                    res[i].site +
                    "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () { },
    });
}

function getOrderNo() {
    $.ajax({
        type: "GET",
        url: "/qc/DamageCheckingRecordsHeaderController/getOrderNo",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () { },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            for (var i = 0; i < res.length; i++) {
                $("#customer_order_plan_data_id").append(
                    '<option value="' +
                    res[i].customer_order_plan_data_id +
                    '">' +
                    res[i].factory_po_num + " - " +
                    res[i].product_name +
                    "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () { },
    });
}

function getProductPrimaryId() {
    $.ajax({
        type: "GET",
        url: "/qc/DamageCheckingRecordsHeaderController/getProductPrimaryId",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () { },
        success: function (response) {
            var res = response.data.result;
            for (var i = 0; i < res.length; i++) {
                $("#product_primary_id").append(
                    '<option value="' +
                    res[i].product_primary_id +
                    '">' +
                    res[i].product_name +
                    "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () { },
    });
}

function saveSclRecord() {
    var scl_data = {};
    var scl_material_data = {};
    var scl_data_arr = tableData.dataSource();
    var scl_material_data_arr = tableDataMaterial.dataSource();
    for (var i = 0; i < scl_data_arr.length; i++) {
        if (!scl_data_arr[i][0]) {
            showWarningMessage("You shuld fill empty row in The list");
            return;
        }
        scl_data[i] = JSON.stringify({
            machinery_id: scl_data_arr[i][0],
            remarks: scl_data_arr[i][1],
        });
    }

    for (var i = 0; i < scl_material_data_arr.length; i++) {
        if (!scl_material_data_arr[i][0]) {
            showWarningMessage("You shuld fill empty row in The list");
            return;
        }
        scl_material_data[i] = JSON.stringify({
            mt_id: scl_material_data_arr[i][0],
            remarks: scl_material_data_arr[i][1],
        });
    }

    swal({
        title: "Are you sure want to approve",
        icon: "warning",
        buttons: {
            confirm: {
                text: "Yes",
                visible: true,
                value: true,
                className: "btn btn-primary",
                closeModal: true,
            },
            cancel: {
                text: "No",
                visible: true,
                value: false,
                className: "btn btn-danger",
                closeModal: true,
            }
        }
    }).then((value) => {
        if (value == true) {
            $.ajax({
                type: "POST",
                url: "/qc/SupervisorCheckListDataController/save",
                data: {
                    reference_no: $("#reference_no").val(),
                    date: $("#date").val(),
                    customer_order_plan_data_id: $(
                        "#customer_order_plan_data_id"
                    ).val(),
                    product_primary_id: $("#product_primary_id").val(),
                    shift_id: $("#shift").val(),
                    factory: $("#factory").val(),
                    net_size: $("#net_size").val(),
                    siever_magnet: $("#siever_magnet").val(),
                    scales_mixing_area: $("#scales_mixing_area").val(),
                    scales_finished_good_area: $("#scales_finished_good_area").val(),
                    volume_bucket_accuracy: $("#volume_bucket_accuracy").val(),
                    no_of_qcs: $("#no_of_qcs").val(),
                    qc_allocated_places: $("#qc_allocated_places").val(),
                    scl_data: scl_data,
                    scl_material_data: scl_material_data,
                },
                headers: {
                    "X-CSRF-TOKEN": $('meta[name="csrf-token"]').attr("content"),
                },
                timeout: 800000,
                beforeSend: function () { },
                success: function (response) {
                    console.log(response);
                    if (response.data.success) {
                        toastr.success("data saved");
                        $("#tblData")
                            .find("input[type=text], select")
                            .each(function () {
                                $(this).val("");
                            });

                        $("#tblDataMaterial")
                            .find("input[type=text], select")
                            .each(function () {
                                $(this).val("");
                            });

                        $("#product_primary_id").val("");
                        $("#customer_order_plan_data_id").val("");
                        $("#date").val("");
                        tableData.reset();
                    } else {
                        showErrorMessage();
                    }
                },
                error: function (error) {
                    console.log(error);
                    toastr.error("Something went wrong");
                },
                complete: function () { },
            });
        }
    });
}

function getSclData(id) {
    $.ajax({
        type: "GET",
        url: "/qc/SupervisorCheckListDataController/getSclData/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {
            // progress(true);
        },
        success: function (response) {
            var res = response.data.result;
            $("#reference_no").val(res.reference_no);
            $("#date").val(res.date);
            $("#customer_order_plan_data_id").val(
                res.customer_order_plan_data_id
            );
            $("#product_primary_id").val(res.product_primary_id);
            $("#shift").val(res.shift_id);
            $("#factory").val(res.factory);

            $("#net_size").val(res.request_data.net_size);
            $("#siever_magnet").val(res.request_data.siever_magnet);
            $("#scales_mixing_area").val(res.request_data.scales_mixing_area);
            $("#scales_finished_good_area").val(res.request_data.scales_finished_good_area);
            $("#volume_bucket_accuracy").val(res.request_data.volume_bucket_accuracy);
            $("#no_of_qcs").val(res.request_data.no_of_qcs);
            $("#qc_allocated_places").val(res.request_data.qc_allocated_places)

            var request_machine_data = res.request_machine_data;
            var request_material_data = res.request_material_data;


            for (var i = 0; i < request_material_data.length; i++) {
                tableDataMaterial.addRow([
                    {
                        type: "select",
                        val: request_material_data[i].mt_id,
                        align: "left",
                        width: "150px",
                    },
                    {
                        type: "text",
                        val: request_material_data[i].remarks,
                        align: "left",
                    },
                    {
                        type: "remove",
                        val: "X",
                        align: "center",
                    },
                ]);
                addRowDataMaterial(request_material_data[i].mt_id);
            }

            for (var i = 0; i < request_machine_data.length; i++) {
                tableData.addRow([
                    {
                        type: "select",
                        val: request_machine_data[i].machinery_id,
                        align: "left",
                        width: "150px",
                    },
                    {
                        type: "text",
                        val: request_machine_data[i].remarks,
                        align: "left",
                    },
                    {
                        type: "remove",
                        val: "X",
                        align: "center",
                    },
                ]);

                addRowDataMachine(request_machine_data[i].machinery_id);
            }

        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {
            // progress(false);
        },
    });
}

function updateSclRecords(scl_id) {
    var scl_data = {};
    var scl_material_data = {};
    var scl_data_arr = tableData.dataSource();
    var scl_material_data_arr = tableDataMaterial.dataSource();
    for (var i = 0; i < scl_data_arr.length; i++) {
        if (!scl_data_arr[i][0]) {
            showWarningMessage("You shuld fill empty row in The list");
            return;
        }
        scl_data[i] = JSON.stringify({
            machinery_id: scl_data_arr[i][0],
            remarks: scl_data_arr[i][1],
        });
    }

    for (var i = 0; i < scl_material_data_arr.length; i++) {
        if (!scl_material_data_arr[i][0]) {
            showWarningMessage("You shuld fill empty row in The list");
            return;
        }
        scl_material_data[i] = JSON.stringify({
            mt_id: scl_material_data_arr[i][0],
            remarks: scl_material_data_arr[i][1],
        });
    }

    swal({
        title: "Are you sure want to approve",
        icon: "warning",
        buttons: {
            confirm: {
                text: "Yes",
                visible: true,
                value: true,
                className: "btn btn-primary",
                closeModal: true,
            },
            cancel: {
                text: "No",
                visible: true,
                value: false,
                className: "btn btn-danger",
                closeModal: true,
            }
        }
    }).then((value) => {
        if (value == true) {
            $.ajax({
                type: "PUT",
                url: "/qc/SupervisorCheckListDataController/update/" + scl_id,
                data: {
                    reference_no: $("#reference_no").val(),
                    date: $("#date").val(),
                    customer_order_plan_data_id: $(
                        "#customer_order_plan_data_id"
                    ).val(),
                    product_primary_id: $("#product_primary_id").val(),
                    shift_id: $("#shift").val(),
                    factory: $("#factory").val(),
                    net_size: $("#net_size").val(),
                    siever_magnet: $("#siever_magnet").val(),
                    scales_mixing_area: $("#scales_mixing_area").val(),
                    scales_finished_good_area: $("#scales_finished_good_area").val(),
                    volume_bucket_accuracy: $("#volume_bucket_accuracy").val(),
                    no_of_qcs: $("#no_of_qcs").val(),
                    qc_allocated_places: $("#qc_allocated_places").val(),
                    scl_data: scl_data,
                    scl_material_data: scl_material_data,
                },
                headers: {
                    "X-CSRF-TOKEN": $('meta[name="csrf-token"]').attr("content"),
                },
                timeout: 800000,
                beforeSend: function () { },
                success: function (response) {
                    console.log(response);
                    if (response.data.success) {
                        toastr.success("data updated");
                        location.href = "/qc/supervisorCheckingList";
                    } else {
                        showErrorMessage();
                    }
                },
                error: function (error) {
                    console.log(error);
                    toastr.error("Something went wrong");
                },
                complete: function () { },
            });
        }
    });


}

function triggerRowInputs(id, selected_row) {


}

/**
 * showSuccessMessage
 * This function is used to show success message.
 * @param message This is the paramter to require message content
 */
function showSuccessMessage(message) {
    toastr.success(message);
}

/**
 * showWarningMessage
 * This function is used to show warning message.
 * @param message This is the paramter to require message content
 */
function showWarningMessage(message) {
    toastr.warning(message);
}

/**
 * showErrorMessage
 * This function is used to show error message.
 * @param message This is the paramter to require message content
 */
function showErrorMessage() {
    toastr.error("Something went wrong");
}
